Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data

Imports Syncfusion.Windows.Forms.Chart
Imports Syncfusion.Drawing

Public Class Form1
    Inherits System.Windows.Forms.Form

    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem


    Private Sub contextMenuStrip1_ItemClicked(ByVal sender As Object, ByVal e As ToolStripItemClickedEventArgs)
        MessageBox.Show("Exit")

    End Sub

    Private Sub InitializeControlSettings()
        Me.ChartControl1.Font = New System.Drawing.Font("Arial", 12.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, (CByte(0)))

        ' Specify a ChartPalette:
        Dim color As Color() = New Color() {System.Drawing.Color.FromArgb(185, 73, 141, 238), System.Drawing.Color.FromArgb(185, 247, 179, 78), System.Drawing.Color.FromArgb(185, 186, 66, 30)}
        Me.ChartControl1.Palette = ChartColorPalette.Custom
        Me.ChartControl1.Model.ColorModel.CustomColors = color
        Me.ChartControl1.Palette = ChartColorPalette.Custom

        Me.ChartControl1.ChartInterior = New Syncfusion.Drawing.BrushInfo(185, New Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.LightBlue, System.Drawing.Color.Azure))
        Me.ChartControl1.LegendPosition = ChartDock.Top
        Me.ChartControl1.HidePartialLabels = True
    End Sub

    Protected Sub InitializeChartData()
        Dim random As Random = New Random()

        Dim series1 As ChartSeries = Me.chartControl1.Model.NewSeries("Series 1", ChartSeriesType.Column)
        series1.Text = series1.Name
        series1.Points.Add(0, 40)
        series1.Points.Add(1, 45)
        series1.Points.Add(2, 20)
        series1.Points.Add(3, 30)
        series1.Points.Add(4, 70)
        AddHandler ContextMenuStrip1.ItemClicked, AddressOf Me.contextMenuStrip1_ItemClicked
        Me.chartControl1.Series.Add(series1)

    End Sub

    Private Sub ChartControl1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChartControl1.Click

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        InitializeControlSettings()
        InitializeChartData()
    End Sub

    Private clickedCP As ChartPoint
    Private clickedPointIndex As Integer
    Private Sub ChartControl1_ChartRegionClick(ByVal sender As System.Object, ByVal e As Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventArgs) Handles ChartControl1.ChartRegionClick
        clickedCP = Me.ChartControl1.ChartArea.GetValueByPoint(New Point(e.Point.X, e.Point.Y))
        Dim pt As Point = Me.ChartControl1.ChartArea.GetPointByValue(clickedCP)
        clickedPointIndex = e.Region.PointIndex
        If e.Region.IsChartPoint Then
            BuildContextOnPoints(pt)

        End If
    End Sub

    Private Sub BuildContextOnPoints(ByVal pt As Point)
        Me.contextMenuStrip1.Items.Clear()
        Me.contextMenuStrip1.Items.Add("Menu")
        Me.contextMenuStrip1.Show(Me.chartControl1, pt.X, pt.Y)
    End Sub
End Class
